明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2084|回复: 4

为什么多边形边的延长线上的点与多边形用IntersectWith求交点时候返回值也不为空

[复制链接]
发表于 2006-4-16 16:48:00 | 显示全部楼层 |阅读模式

写了一个判断点是否在多边形的某条边上的程序,
以白色部分作为边界的时候,当取某条边延长线(红色部分)上的点时,

请问什么结果不正确?

Private Sub TestOnBoundary()
  Dim TestPoint As Variant
  Dim Util As AcadUtility
  Dim Entity As AcadEntity
  Dim PickPt As Variant
                                                              
  Set Util = ThisDrawing.Utility
  On Error GoTo Done
  Util.GetEntity Entity, PickPt, "Select region: "
  Do While (True)
    TestPoint = Util.GetPoint(, vbCrLf & "Test point: ")
    If IsPointOnBoundary(TestPoint, Entity) Then
      Util.Prompt (vbCrLf & "Point is on the boundary")
    Else
      Util.Prompt (vbCrLf & "Point is not on the boundary")
    End If
  Loop
Done:
End Sub

Private Function IsPointOnBoundary( _
                ByVal varPnt As Variant, _
                ByVal objBoundary As AcadEntity) As Boolean
  Dim objDoc As AcadDocument
  Dim objBlock As AcadBlock
  Dim objPnt As AcadPoint
  Dim varPnts As Variant
               
  Set objDoc = objBoundary.Document
  Set objBlock = objDoc.ObjectIdToObject(objBoundary.OwnerID)
 
  Set objPnt = objBlock.AddPoint(varPnt)
  varPnts = objPnt.IntersectWith(objBoundary, acExtendNone)
  IsPointOnBoundary = UBound(varPnts) > 0
  objPnt.Delete
               
End Function

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有账号?注册

x
发表于 2006-4-18 21:35:00 | 显示全部楼层

点和实体怎么会有交点?

过该点做一条直线,如果直线和边界的交点在该点,则点在边界上

 楼主| 发表于 2006-4-19 09:05:00 | 显示全部楼层

点在边界上的时候当然就有交点了,如果没记错的话做射线那种方法测的是否在边界内部

发表于 2006-4-19 13:32:00 | 显示全部楼层

仔细看一下我的方法!和以前的射线法不一样的

 楼主| 发表于 2006-4-19 20:52:00 | 显示全部楼层
明白了:)
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-27 06:21 , Processed in 0.160617 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表